<!DOCTYPE html>

<html>

  <head>

    <title>Antes e Agora</title>

    <script src="https://cdn.jsdelivr.net/npm/exif-js"></script>

    <!--
      The `defer` attribute causes the script to execute after the full HTML document has been parsed. For non-blocking uses, avoiding race conditions, and consistent
      behavior across browsers, consider loading using Promises. See https://developers.google.com/maps/documentation/javascript/load-maps-js-api for more information.
      -->
    <script src="https://maps.googleapis.com/maps/api/js?v=weekly&loading=async&key=AIzaSyB41DRUbKWJHPxaFjMAwdrzWzbVKartNGg&callback=initPano" async></script>

    <script>

      // http://github.com/exif-js/exif-js

      window.onload = function()
      {

        var imagesPreview = function(input)
        {

          var data = new Object();

          for (var i=0; i<input.files.length; i++)
          {

            ( // Looping through files for FileReader, output always contains last value from loop <http://stackoverflow.com/a/9815648>

              function(file)
              {

                var prop  = new Object();
                prop.name = file.name;
                prop.size = file.size;

                EXIF.getData
                (
                  file,
                  function()
                  {
                    const re  = /^([0-9]{4}):([0-9]{2}):/;
                    var dt = EXIF.getTag(this, "DateTime").replace(/:/g,"").replace(/ /g,"_");
                    prop.exif = EXIF.getAllTags(this);
                    document.getElementById('photo-list').innerHTML += `<div class="photo-container"><img id="${dt}" class="photo" onclick="photoRead(this)"></div>`;
                    document.getElementById('exif-data' ).innerHTML += `<div class="exif-data">`
                                                                    +  `${prop.name}<br>`
                                                                    +  `${prop.size}<br>`
                                                                    +  `${dt}<br>`
                                                                    +  `${JSON.stringify(prop.exif, null, 2)}</div>`
                                                                    +  `</div>`;
                    var reader = new FileReader();
                    reader.onload = function(e)
                    {
                      var img = new Image();
                      img.src = e.target.result;
                    }
                    reader.readAsDataURL(this);
                    data[dt] = prop;
                  }
                );

              }

            )(input.files[i]);

          }

       // var odata = sortObj(data);
       // var odata = Object.fromEntries(Object.entries(data).sort());

          console.log(data);
          console.log(typeof data);
          console.log(Object.keys(data).length);
          console.log(data["20240625_144126"]);
          console.log(Object.keys(data));

        };

        document.getElementById('photo-load').onchange = function(e){ imagesPreview(this) };

      }



      const sortObj = o=>Object.keys(o).sort().reduce((r,k)=>(r[k]=o[k],r),{});



      function photoRead(file)
      {
        EXIF.getData
        (
          file,
          function() { readExif(this) }
        );
      }



      function readExif(data)
      {
        lng60 = EXIF.getTag(data, "GPSLongitude");
        lngR  = EXIF.getTag(data, "GPSLongitudeRef");
        lat60 = EXIF.getTag(data, "GPSLatitude");
        latR  = EXIF.getTag(data, "GPSLatitudeRef");
        document.getElementById("lng" ).innerHTML = (lngR=="E"?1:-1) * ( lng60[0] + lng60[1]/60 + lng60[2]/60/60 );
        document.getElementById("lat" ).innerHTML = (latR=="N"?1:-1) * ( lat60[0] + lat60[1]/60 + lat60[2]/60/60 );
        document.getElementById("cmm" ).innerHTML = `${EXIF.getTag(data, "Make")}/${EXIF.getTag(data, "Model")}`;
        document.getElementById("size").innerHTML = EXIF.getTag(data, "ImageSize");
        document.getElementById("date").innerHTML = EXIF.getTag(data, "DateTime");
        document.getElementById("iso" ).innerHTML = EXIF.getTag(data, "ISOSpeedRatings");
        document.getElementById("stp" ).innerHTML = EXIF.getTag(data, "ShutterSpeed");
        document.getElementById("all" ).innerHTML = `<pre>${JSON.stringify(EXIF.getAllTags(data), null, 2)}</pre>`;
        initPano();
      }



      function initPano()
      {

        const panorama = new google.maps.StreetViewPanorama
        (
          document.getElementById("pano"),
          {
            position:
            {
              lng: parseFloat(document.getElementById("lng" ).innerHTML),
              lat: parseFloat(document.getElementById("lat" ).innerHTML),
            },
            pov:
            {
              heading: 0,
              pitch: 0,
            },
            visible: true,
          },
        );

        panorama.addListener
        (
          "pano_changed", () =>
          {
            const panoCell = document.getElementById("pano-cell");
            panoCell.innerHTML = panorama.getPano();
          }
        );

        panorama.addListener
        (
          "links_changed", () =>
          {
            const linksTable = document.getElementById("links_table");
            while (linksTable.hasChildNodes())
            {
              linksTable.removeChild(linksTable.lastChild);
            }
            const links = panorama.getLinks();
            for (const i in links)
            {
              const row = document.createElement("tr");
              linksTable.appendChild(row);
              const labelCell = document.createElement("td");
              labelCell.innerHTML = "<b>Link: " + i + "</b>";
              const valueCell = document.createElement("td");
              valueCell.innerHTML = links[i].description;
              linksTable.appendChild(labelCell);
              linksTable.appendChild(valueCell);
            }
          }
        );

        panorama.addListener
        (
          "position_changed", () =>
          {
            const positionCell = document.getElementById("position-cell");
            positionCell.firstChild.nodeValue = panorama.getPosition() + "";
          }
        );

        panorama.addListener
        (
          "pov_changed", () =>
          {
            const headingCell = document.getElementById("heading-cell");
            const pitchCell = document.getElementById("pitch-cell");
            headingCell.firstChild.nodeValue = panorama.getPov().heading + "";
            pitchCell.firstChild.nodeValue = panorama.getPov().pitch + "";
          }
        );

      }

    </script>



    <style>

      #map
      {
        height: 100%;
      }

      html,
      body
      {
        height: 100%;
        margin: 0;
        padding: 0;
      }

      #floating-panel
      {
        position: absolute;
        top: 10px;
        left: 25%;
        z-index: 5;
        background-color: #fff;
        padding: 0;
        border: 1px solid #999;
        text-align: center;
        font-family: "Roboto", "sans-serif";
      }

      #pano
      {
        width: 50%;
        height: 100%;
        float: left;
      }

      #floating-panel
      {
        width: 50%;
        height: 100%;
        float: right;
        text-align: left;
        overflow: auto;
        position: static;
        border: 0 solid #999;
      }

      h2
      {
        background: black;
        color: white;
        padding-left: 5px;
        margin: 0;
      }

      input
      {
        margin: 10px 0 0 10px;
      }

      table
      {
        margin: 0 0 10px 10px;
      }

      .photo-container
      {
        min-width: 30px;
        height: 100px;
        border-right: 1px solid black;
        display: inline-block;
        background: lightgray;
      }

      .photo
      {
        display: none;
        height: 100px;
      }

      .photo[src]
      {
        display: block;
      }

      #photo-list
      {
        height: 100px;
        margin: 10px 10px 0 10px;
        overflow: auto;
        border: 1px solid black;
        white-space: nowrap;
      }

      .exif-data
      {
        border: 1px solid red;
      }

    </style>

  </head>

  <body>

    <div id="pano"></div>

    <div id="floating-panel">

      <h2>Street View</h2>

      <table>
        <tr> <td><b>Position   </b></td> <td id="position-cell">&nbsp;</td> </tr>
        <tr> <td><b>POV Heading</b></td> <td id="heading-cell" >&nbsp;</td> </tr>
        <tr> <td><b>POV Pitch  </b></td> <td id="pitch-cell"   >&nbsp;</td> </tr>
        <tr> <td><b>Pano ID    </b></td> <td id="pano-cell"    >&nbsp;</td> </tr>
      </table>

      <table id="links_table"></table>

      <h2>Fotos</h2>

      <input id="photo-load" type="file" accept=".jpg" multiple/><br>

      <div id="photo-list"></div>
      <div id="exif-data"></div>

      <table>
        <tr> <td><b>Latitude          </b></td> <td id="lat" ></td> </tr>
        <tr> <td><b>Longitude         </b></td> <td id="lng" ></td> </tr>
        <tr> <td><b>Camera Maker/Model</b></td> <td id="cmm" ></td> </tr>
        <tr> <td><b>Width x Height    </b></td> <td id="size"></td> </tr>
        <tr> <td><b>Capture Date      </b></td> <td id="date"></td> </tr>
        <tr> <td><b>ISO SpeedRatings  </b></td> <td id="iso" ></td> </tr>
        <tr> <td><b>Shutter Speed     </b></td> <td id="stp" ></td> </tr>
        <tr> <td>&nbsp;</td> <td></td> </tr>
        <tr> <td valign="top"><b>All Metadata</b></td> <td id="all"></span></p>
      </div>

    </div>

  </body>

</html>
